;Marios Home
Const LEVEL_MARIO_CASTLE=0,LEVEL_MARIO_LIGHT=4,LEVEL_MARIO_TERRAIN=8,LEVEL_MARIO_T_TEXTURE=12
l.level=New level
l\maxx=600
l\minx=-600
l\maxy=200
l\miny=-185
l\name="Castle"

tmp=Label2()
If proginit
	l\lblInit=tmp
Else
	l\bnkInfo=CreateBank(16)
	PokeInt l\bnkInfo,LEVEL_MARIO_CASTLE,LoadMesh("castle.x")
	EntityType PeekInt(l\bnkInfo,LEVEL_MARIO_CASTLE),COLLISION_LEVEL
	PositionEntity PeekInt(l\bnkInfo,LEVEL_MARIO_CASTLE),0,-195,0
	ScaleEntity PeekInt(l\bnkInfo,LEVEL_MARIO_CASTLE),0.5,0.5,0.5
	
	PokeInt l\bnkInfo,LEVEL_MARIO_LIGHT,CreateLight()
	TurnEntity PeekInt(l\bnkInfo,LEVEL_MARIO_LIGHT),80,0,0
	
	PokeInt l\bnkInfo,LEVEL_MARIO_TERRAIN,CreatePlane()
	PositionEntity PeekInt(l\bnkInfo,LEVEL_MARIO_TERRAIN),0,-195,0
	
	PokeInt l\bnkInfo,LEVEL_MARIO_T_TEXTURE,LoadTexture("grass.jpg")
	ScaleTexture PeekInt(l\bnkInfo,LEVEL_MARIO_T_TEXTURE),50,50
	EntityTexture PeekInt(l\bnkInfo,LEVEL_MARIO_TERRAIN),PeekInt(l\bnkInfo,LEVEL_MARIO_T_TEXTURE)
	
	
	spawn[0] = New SpawnPoint
	spawn[0]\x=-200
	spawn[0]\y=100
	
	spawn[1] = New SpawnPoint
	spawn[1]\x=-100
	spawn[1]\y=100
	
	spawn[2] = New SpawnPoint
	spawn[2]\x=100
	spawn[2]\y=100
	
	spawn[3] = New SpawnPoint
	spawn[3]\x=200
	spawn[3]\y=100
	
	CameraClsColor camera,0,255,255
	
	Return
EndIf

tmp=Label2()
If proginit
	l\lblLevel=tmp
Else
	
	Return
EndIf

Const LEVEL_HOLO_WORLD=0,LEVEL_HOLO_TEX=4,LEVEL_HOLO_COURSE=8,LEVEL_HOLO_LIGHT=12,LEVEL_HOLO_FRAME=16,LEVEL_HOLO_TIME=17
;Holo-Arena

l.level=New level
l\maxx=400
l\minx=-400
l\maxy=200
l\miny=-80
l\name="Holo-Arena"

tmp=Label2()
If proginit
	l\lblInit=tmp
Else
	l\bnkInfo=CreateBank(21)
	
	PokeInt l\bnkInfo,LEVEL_HOLO_WORLD,CreateCube()
	ScaleEntity PeekInt(l\bnkInfo,LEVEL_HOLO_WORLD),500,500,500
	FlipMesh PeekInt(l\bnkInfo,LEVEL_HOLO_WORLD)
	MoveEntity PeekInt(l\bnkInfo,LEVEL_HOLO_WORLD),0,400,0
	PokeInt l\bnkInfo,LEVEL_HOLO_TEX,CreateTexture(64,64,0,4)
	SetBuffer TextureBuffer(PeekInt(l\bnkInfo,LEVEL_HOLO_TEX),0)
	;[Block]
	ClsColor 0,0,255
	Cls
	Color 255,0,0
	Rect 0,0,32,1
	Rect 0,0,1,64
	;[End Block]
	SetBuffer TextureBuffer(PeekInt(l\bnkInfo,LEVEL_HOLO_TEX),1)
	;[Block]
	ClsColor 0,0,255
	Cls
	Color 255,0,0
	Rect 16,0,32,1
	Rect 0,0,1,64
	;[End Block]
	SetBuffer TextureBuffer(PeekInt(l\bnkInfo,LEVEL_HOLO_TEX),2)
	;[Block]
	ClsColor 0,0,255
	Cls
	Color 255,0,0
	Rect 32,0,32,1
	Rect 0,0,1,64
	;[End Block]
	SetBuffer TextureBuffer(PeekInt(l\bnkInfo,LEVEL_HOLO_TEX),3)
	;[Block]
	ClsColor 0,0,255
	Cls
	Color 255,0,0
	Rect 0,0,16,1
	Rect 48,0,16,1
	Rect 0,0,1,64
	;[End Block]
	SetBuffer BackBuffer()
	ScaleTexture PeekInt(l\bnkInfo,LEVEL_HOLO_TEX),.1,.1
	EntityTexture PeekInt(l\bnkInfo,LEVEL_HOLO_WORLD),PeekInt(l\bnkInfo,LEVEL_HOLO_TEX),0
	
	PokeInt l\bnkInfo,LEVEL_HOLO_COURSE,CreatePivot()
	PositionEntity LEVEL_HOLO_PlayerMesh(PeekInt(l\bnkInfo,LEVEL_HOLO_COURSE)),380,-90,0,True
	
	EntityType LEVEL_HOLO_CreateWorld(0),COLLISION_LEVEL,True
	
	EntityType PeekInt(l\bnkInfo,LEVEL_HOLO_WORLD),COLLISION_LEVEL
	
	PokeInt l\bnkInfo,LEVEL_HOLO_LIGHT,CreateLight()
	TurnEntity PeekInt(l\bnkInfo,LEVEL_HOLO_LIGHT),80,0,0
	
	
	spawn[0] = New SpawnPoint
	spawn[0]\x=-200
	spawn[0]\y=100
	
	spawn[1] = New SpawnPoint
	spawn[1]\x=-100
	spawn[1]\y=100
	
	spawn[2] = New SpawnPoint
	spawn[2]\x=100
	spawn[2]\y=100
	
	spawn[3] = New SpawnPoint
	spawn[3]\x=200
	spawn[3]\y=100
	
	Return
EndIf

tmp=Label2()
If proginit
	l\lblLevel=tmp
Else
	TurnEntity PeekInt(l\bnkInfo,LEVEL_HOLO_COURSE),0,3,0
	
	If PeekInt(l\bnkInfo,LEVEL_HOLO_TIME)<MilliSecs()
		PokeByte l\bnkInfo,LEVEL_HOLO_FRAME,(PeekByte(l\bnkInfo,LEVEL_HOLO_FRAME)+1) Mod 4
		EntityTexture PeekInt(l\bnkInfo,LEVEL_HOLO_WORLD),PeekInt(l\bnkInfo,LEVEL_HOLO_TEX),PeekByte(l\bnkInfo,LEVEL_HOLO_FRAME)
		PokeInt l\bnkInfo,LEVEL_HOLO_TIME,MilliSecs()+500
	EndIf
	
	
	Return
EndIf

Function LEVEL_HOLO_PlayerMesh(q)
	Local p,c1,c2,c3,c4,b
	p=CreatePivot(q)
	c1=CreateCube(p)
	ScaleMesh c1,4,2,10
	b=CreateBrush()
	BrushColor b,255,0,0
	PaintMesh c1,b
	c2=CreateCylinder(16,True,p)
	ScaleMesh c2,1,6,1
	RotateMesh c2,0,0,90
	PositionMesh c2,0,0,-8
	b=CreateBrush()
	BrushColor b,255,0,0
	PaintMesh c2,b
	c3=CreateCylinder(16,True,p)
	ScaleMesh c3,2,2,2
	RotateMesh c3,90,0,0
	PositionMesh c3,7,0,-8
	b=CreateBrush()
	BrushColor b,255,255,255
	PaintMesh c3,b
	c4=CreateCylinder(16,True,p)
	ScaleMesh c4,2,2,2
	RotateMesh c4,90,0,0
	PositionMesh c4,-7,0,-8
	b=CreateBrush()
	BrushColor b,255,255,255
	PaintMesh c4,b
	
	ScaleEntity p,5,5,5
	Return p
End Function

Function LEVEL_HOLO_CreateWorld(q=0)
	Local m,c
	
	m=CreatePivot(q)
	
	c=CreateCube(m)
	ScaleEntity c,300,20,20
	PositionEntity c,0,-50,0,True
	
	c=CreateCube(m)
	ScaleEntity c,20,100,20
	PositionEntity c,-280,-150,0,True
	
	c=CreateCube(m)
	ScaleEntity c,20,100,20
	PositionEntity c,+280,-150,0,True
	
	Return m
End Function
;~IDEal Editor Parameters:
;~C#Blitz3D