Type phxEntity
	Field vx#,ox#
	Field vy#,oy#
	Field ax#
	Field ay#
	Field entModel
	Field state				;0=ground,1=inair,2=juped
End Type

Const COLLISION_LEVEL=2,COLLISION_PLAYER=1,COLLISION_POLIGON=2,COLLISION_SPHERE=1,COLLISION_SLIDE=2

Collisions COLLISION_PLAYER,COLLISION_LEVEL,COLLISION_POLIGON,COLLISION_SLIDE
Collisions COLLISION_PLAYER,COLLISION_PLAYER,COLLISION_SPHERE,COLLISION_SLIDE

Function Physix()
	Local phx.phxEntity
	For phx=Each phxEntity
		phx\ox=EntityX(phx\entModel)
		phx\oy=EntityY(phx\entModel)
		
		PositionEntity phx\entModel,phx\ox+phx\vx+phx\ax,phx\oy+phx\vy+phx\ay,0
	Next
	
	UpdateWorld;PositionEntity+ Updateworld->Neue position
	
	For phx=Each phxEntity
		phx\vx=EntityX(phx\entModel)-phx\ox
		phx\vy=EntityY(phx\entModel)-phx\oy
		
		If EntityCollided(phx\entModel,COLLISION_LEVEL)
			phx\state=0
		Else
			phx\state=1
		EndIf
		
		;If auerhalb vom level
		If EntityY(phx\entModel)<currentlevel\miny Or EntityY(phx\entModel)>currentlevel\maxy Or EntityX(phx\entModel)<currentlevel\minx Or EntityX(phx\entModel)>currentlevel\maxx
			KillPhx(phx)
		EndIf
		
		If phx\state=0
			phx\ax=-phx\vx*0.2;Reibung an der Erde
		Else
			phx\ax=-phx\vx*0.1;Luftwiderstand
		EndIf
		
		phx\ay=-phx\vy*0.1-0.5;Schwerkraft
		
		
	Next
	
End Function

Function KillPhx(phx.phxEntity)
	Local count
	For count= 0 To 3
		If player[count]<>Null
			If player[count]\phx=phx
				EntityType phx\entModel,0
				PositionEntity phx\entModel,spawn[count]\x,spawn[count]\y,0
				EntityType phx\entModel,COLLISION_PLAYER
				phx\vx=0
				phx\vy=0
				player[count]\percent=0
				Return
			EndIf
		EndIf
	Next
	
End Function
;~IDEal Editor Parameters:
;~C#Blitz3D