Global proginit=1,player.player[3],currentlevel.level,spawn.SpawnPoint[3]
;Virtuelle Tasten:

Local btnUp,btnDown,btnLeft,btnRight,btnAtt1,btnAtt2,btnSmash

;Reale Tasten

Const KEY_W=17,KEY_A=30,KEY_S=31,KEY_D=32,KEY_SHIFT_LEFT=42,KEY_SPACE=57,KEY_Q=16,KEY_E=18,KEY_F=33
Const KEY_UP=200,KEY_DOWN=208,KEY_LEFT=203,KEY_RIGHT=205,KEY_NUM_0=82,KEY_STRG_RIGHT=157,KEY_PLUS=27,KEY_CROSS=43
Const MB_L=1,MB_R=2
Const JB_A1=1,JB_A2=2


Local count,timer,camera,countcount,icon,font

Local at.Attacktype,a.Attack
Local p.player,c.character,tmp
Local l.level


Include "titlescreen.bb"
Include "attack.bb"
Include "attackdata.bb"
Include "dust.bb"
Include "player.bb"
Include "level.bb"
Include "playerdata.bb"
Include "leveldata.bb"
Include "physics.bb"
Include "camera.bb"
Include "Draw3D.bb"

;-- Player Select Simple
proginit=0

For count=0 To 3
	Print "Welcome player "+(count+1)+"!"
	Print "Chose a character:"
	
	Print "0) <NO CHARACTER>"
	countcount=0
	For c=Each character
		countcount=countcount+1
		Print countcount+") "+c\name
	Next
	
	Repeat
		tmp=Input(">")
		If tmp=0 Then Exit
		
		countcount=0
		For c=Each character
			countcount=countcount+1
			If countcount=tmp
				Exit
			EndIf
		Next
	Until c<>Null
	
	If c<>Null ;tritt ein wenn der spieler ber tmp=0  die schleife verlsst
		Print ">"+c\name
		
		GoSub2 c\lblInit 
		player[count]=p
	
		Print "Chose an input device:"
		Print "1) Keyboard left"
		Print "2) Keyboard right"
		Print "3) Mouse"
		Print "4) Joystick"
		Print "5) AI"
		Repeat
			tmp=Input(">")
		Until tmp>0 And tmp<6 And ((tmp=5 And c\lblKI[0]<>0) Or tmp<>5)
		
		p\devInput=tmp
	Else
		Print "<NO CHARACTER>"
	EndIf
	Print ""
Next
	
;--3D Setup
camera=CreateCamera()
PositionEntity camera,0,0,-100
TurnEntity camera,0,0,0

DrawInit3D(camera)
Origin3D 800,600
icon=LoadImage3D("GMaxA.png")
font=LoadFont3D("Babylon1.png")

;-- Stage Select simple
Print "Select a level!"

Repeat
	countcount=0
	For l=Each level
		countcount=countcount+1
		Print countcount+") "+l\name
	Next
	
	tmp=Input(">")
	
	countcount=0
	For l=Each level
		countcount=countcount+1
		If countcount=tmp
			Exit
		EndIf
	Next
Until l<>Null

currentlevel=l
GoSub2 l\lblInit


For count=0 To 3
	If player[count]<>Null
		KillPhx(player[count]\phx)
	EndIf
Next

;//Ingame:

timer=CreateTimer(60)

Repeat
	
	For a=Each Attack
		GoSub2 a\at\lblMovement
	Next
	
	
	For count=0 To 3
		p=player[count]; Man beachte dass die Label p als Argument erwarten
		
		If p<>Null
			Text3D font,-300+count*200,-220,p\percent+" %",1
			
			Select p\devInput
				Case INP_KEYLEFT
					btnUp	=KeyHit(KEY_E)
					btnDown	=KeyHit(KEY_D)
					btnRight=KeyDown(KEY_F)
					btnLeft	=KeyDown(KEY_S)
					btnAtt1	=KeyHit(KEY_Q)
					btnAtt2	=KeyHit(KEY_A)
				Case INP_MOUSE
					btnUp	=MouseY()<10
					btnDown	=MouseY()>30
					btnRight=MouseX()>30
					btnLeft	=MouseX()<10
					btnAtt1	=MouseHit(MB_L)
					btnAtt2	=MouseHit(MB_R)
					
					If btnUp
						MoveMouse MouseX(),20
					EndIf
					
					If btnDown
						MoveMouse MouseX(),20
					EndIf
					
					If MouseX()>35
						MoveMouse 35,MouseY()
					EndIf
					
					If MouseX()<5
						MoveMouse 5,MouseY()
					EndIf
					
					
				Case INP_KEYRIGHT
					btnUp	=KeyHit(KEY_UP)
					btnDown	=KeyHit(KEY_DOWN)
					btnRight=KeyDown(KEY_RIGHT)
					btnLeft	=KeyDown(KEY_LEFT)
					btnAtt1	=KeyHit(KEY_PLUS)
					btnAtt2	=KeyHit(KEY_CROSS)
				Case INP_JOY
					btnUp	=JoyYDir()<0
					btnDown	=JoyYDir()>0
					btnRight=JoyXDir()>0
					btnLeft	=JoyXDir()<0
					btnAtt1	=JoyHit(JB_A1)
					btnAtt2	=JoyHit(JB_A2)
				Case INP_KI
					GoSub2 p\c\lblKI[p\kilevel]
			End Select
			
			If p\tmeStoned>MilliSecs();Wenn der player nicht gestoned ist
				btnUp	=False		  ;Die Tasten werden Flushkeys-artigtrotzdem abgefragt
				btnDown	=False
				btnRight=False
				btnLeft	=False
				btnAtt1	=False
				btnAtt2	=False
				btnSmash=False
			Else;Die Rechnerei kann man sich sparen wenn man stoned ist
				If btnAtt1 And p\tmeSmash>MilliSecs()
					btnSmash=True
					btnAtt1=False
				ElseIf btnAtt1
					btnSmash=False
					p\tmeSmash=MilliSecs()+100
				Else
					btnSmash=False
				EndIf
			EndIf
			
			GoSub2 p\c\lblMovement
		EndIf
	Next
	
	GoSub2 currentlevel\lblLevel
	
	Physix()
	FocusCamera(camera)
	
	DrawImage3D icon,-300,-220,0,0,2
	DrawImage3D icon,-100,-220,0,0,2
	DrawImage3D icon,100,-220,0,0,2
	DrawImage3D icon,300,-220,0,0,2
	
	
	RenderWorld
	
	Clear3D()
	Flip 0
	WaitTimer timer
Until KeyHit(1)
End
;~IDEal Editor Parameters:
;~C#Blitz3D