;//-- MagicMario (Agent)
Const PLAYER_MAGIC_MARIO_ANIM=0,PLAYER_MAGIC_MARIO_SHIELD=4,PLAYER_MAGIC_MARIO_TEXTURE=8,PLAYER_MAGIC_MARIO_ULTRA=12,PLAYER_MAGIC_MARIO_PARENT=16

;+p\phx\entModel
; +PLAYER_MAGIC_MARIO_PARENT
;  +PLAYER_MAGIC_MARIO_ANIM
;  +PLAYER_MAGIC_MARIO_SHIELD


c.character=New character
c\name="MagicMario"

tmp=Label2();input: c.character ;output:p.player
If proginit
	c\lblInit=tmp
Else
	p=New player
	p\bnkInfo=CreateBank(20)
	p\phx=New phxEntity
	p\phx\entModel=CreatePivot()
	p\c=c
	EntityType p\phx\entModel,COLLISION_PLAYER
	EntityPickMode p\phx\entModel,1
	NameEntity p\phx\entModel,Handle(p)
	
	PokeInt p\bnkInfo,PLAYER_MAGIC_MARIO_PARENT,CreatePivot(p\phx\entModel)
	PokeInt p\bnkInfo,PLAYER_MAGIC_MARIO_ANIM,LoadAnimMesh("player.x",PeekInt(p\bnkInfo,PLAYER_MAGIC_MARIO_PARENT))
	PokeInt p\bnkInfo,PLAYER_MAGIC_MARIO_SHIELD,CreateSphere(16,PeekInt(p\bnkInfo,PLAYER_MAGIC_MARIO_PARENT))
	PositionEntity PeekInt(p\bnkInfo,PLAYER_MAGIC_MARIO_SHIELD),0,0,0
	PositionEntity PeekInt(p\bnkInfo,PLAYER_MAGIC_MARIO_ANIM),0,-7,0
	EntityRadius p\phx\entModel,12
	ScaleEntity PeekInt(p\bnkInfo,PLAYER_MAGIC_MARIO_SHIELD),12,12,12
	PokeInt p\bnkInfo,PLAYER_MAGIC_MARIO_TEXTURE,LoadTexture("shield.jpg")
	EntityTexture PeekInt(p\bnkInfo,PLAYER_MAGIC_MARIO_SHIELD),PeekInt(p\bnkInfo,PLAYER_MAGIC_MARIO_TEXTURE)
	EntityAlpha PeekInt(p\bnkInfo,PLAYER_MAGIC_MARIO_SHIELD),0.5
	
	Return
EndIf	
	
tmp=Label2();input: btnRight,btnLeft,btnUp,btnDown,btnAtt1,btnAtt2,btnSmash,p.player
If proginit
	c\lblMovement=tmp
Else
	If btnRight
		p\phx\ax=p\phx\ax+0.7
		RotateEntity p\phx\entModel,0,-90,0
		If Not Animating(PeekInt(p\bnkInfo,PLAYER_MAGIC_MARIO_ANIM))
			Animate PeekInt(p\bnkInfo,PLAYER_MAGIC_MARIO_ANIM),1,0.5
		EndIf
	EndIf
	
	If btnLeft
		p\phx\ax=p\phx\ax-0.7
		RotateEntity p\phx\entModel,0,90,0
		If Not Animating(PeekInt(p\bnkInfo,PLAYER_MAGIC_MARIO_ANIM))
			Animate PeekInt(p\bnkInfo,PLAYER_MAGIC_MARIO_ANIM),1,0.5
		EndIf
	EndIf
	
	If btnUp
		p\phx\ay=p\phx\ay+10
	EndIf
	
	If btnDown
		p\phx\ay=p\phx\ay-10
	EndIf
	
	If btnAtt1
		If EntityYaw(p\phx\entModel)>0
			ATTACK_KICK_Damage(p,-15,1,-0.1,1)
			Animate PeekInt(p\bnkInfo,PLAYER_MAGIC_MARIO_ANIM),1,0.5
		Else
			ATTACK_KICK_Damage(p,15,1,0.1,1)
			Animate PeekInt(p\bnkInfo,PLAYER_MAGIC_MARIO_ANIM),1,0.5
		EndIf
		p\tmeStoned=MilliSecs()+50
	EndIf
	
	If btnAtt2
		If EntityYaw(p\phx\entModel)>0
			ATTACK_KICK_Damage(p,-15,10,-3,3)
			Animate PeekInt(p\bnkInfo,PLAYER_MAGIC_MARIO_ANIM),1,0.5
		Else
			ATTACK_KICK_Damage(p,15,10,3,3)
			Animate PeekInt(p\bnkInfo,PLAYER_MAGIC_MARIO_ANIM),1,0.5
		EndIf
		p\tmeStoned=MilliSecs()+1000
		PokeInt p\bnkInfo,PLAYER_MAGIC_MARIO_ULTRA,MilliSecs()+1000
	EndIf
	
	If btnSmash
		
	EndIf
	
	If PeekInt(p\bnkInfo,PLAYER_MAGIC_MARIO_ULTRA)<>0
		If PeekInt(p\bnkInfo,PLAYER_MAGIC_MARIO_ULTRA)>MilliSecs()
			RotateEntity PeekInt(p\bnkInfo,PLAYER_MAGIC_MARIO_PARENT),(PeekInt(p\bnkInfo,PLAYER_MAGIC_MARIO_ULTRA)-MilliSecs())/1000.0*360,0,0
		Else
			If EntityYaw(p\phx\entModel)>0
				ATTACK_KICK_Damage(p,-15,10,-4,4)
			Else
				ATTACK_KICK_Damage(p,15,10,4,4)
			EndIf
			PokeInt p\bnkInfo,PLAYER_MAGIC_MARIO_ULTRA,0
		EndIf
	EndIf
	
	
	If p\tmeStoned<MilliSecs()
		If Not(btnRight Or btnLeft) 
			Animate PeekInt(p\bnkInfo,PLAYER_MAGIC_MARIO_ANIM),0
		EndIf
	EndIf
	
	Return
EndIf

;Police
Const PLAYER_POLICE_PARENT=0,PLAYER_POLICE_MODEL=4,PLAYER_POLICE_GO=8,PLAYER_POLICE_SHOT=12,PLAYER_POLICE_SHOTTIME=16

c.character=New character
c\name="Police"

tmp=Label2();input: c.character ;output:p.player
If proginit
	c\lblInit=tmp
Else
	p=New player
	p\bnkInfo=CreateBank(20)
	p\phx=New phxEntity
	p\phx\entModel=CreatePivot()
	p\c=c
	EntityRadius p\phx\entModel,10
	EntityType p\phx\entModel,COLLISION_PLAYER
	EntityPickMode p\phx\entModel,1
	NameEntity p\phx\entModel,Handle(p)
	
	PokeInt p\bnkInfo,PLAYER_POLICE_PARENT,CreatePivot(p\phx\entModel)
	PokeInt p\bnkInfo,PLAYER_POLICE_MODEL,LoadAnimMesh("police.b3d",PeekInt(p\bnkInfo,PLAYER_POLICE_PARENT))
	PositionEntity PeekInt(p\bnkInfo,PLAYER_POLICE_PARENT),0,-10,0
	
	PokeInt p\bnkInfo,PLAYER_POLICE_GO,ExtractAnimSeq(PeekInt(p\bnkInfo,PLAYER_POLICE_MODEL),0,24)
	PokeInt p\bnkInfo,PLAYER_POLICE_SHOT,ExtractAnimSeq(PeekInt(p\bnkInfo,PLAYER_POLICE_MODEL),24,48)
	
	Return
EndIf	

tmp=Label2();input: btnRight,btnLeft,btnUp,btnDown,btnAtt1,btnAtt2,btnSmash,p.player
If proginit
	c\lblMovement=tmp
Else
	If btnRight
		p\phx\ax=p\phx\ax+0.8
		RotateEntity p\phx\entModel,0,-90,0
		If Not Animating(PeekInt(p\bnkInfo,PLAYER_POLICE_MODEL))
			Animate PeekInt(p\bnkInfo,PLAYER_POLICE_MODEL),1,1,PeekInt(p\bnkInfo,PLAYER_POLICE_GO)
		EndIf
	EndIf
	
	If btnLeft
		p\phx\ax=p\phx\ax-0.8
		RotateEntity p\phx\entModel,0,90,0
		If Not Animating(PeekInt(p\bnkInfo,PLAYER_POLICE_MODEL))
			Animate PeekInt(p\bnkInfo,PLAYER_POLICE_MODEL),1,1,PeekInt(p\bnkInfo,PLAYER_POLICE_GO)
		EndIf
	EndIf
	
	If btnUp
		p\phx\ay=p\phx\ay+7
	EndIf
	
	If btnDown
		p\phx\ay=p\phx\ay-7
	EndIf
	
	If btnAtt1
		Animate PeekInt(p\bnkInfo,PLAYER_POLICE_MODEL),3,3,PeekInt(p\bnkInfo,PLAYER_POLICE_SHOT)
		p\tmeStoned=MilliSecs()+200
		PokeInt p\bnkInfo,PLAYER_POLICE_SHOTTIME,1
	EndIf
	
	If btnAtt2
		Animate PeekInt(p\bnkInfo,PLAYER_POLICE_MODEL),3,0.25,PeekInt(p\bnkInfo,PLAYER_POLICE_SHOT)
		p\tmeStoned=MilliSecs()+2000
		PokeInt p\bnkInfo,PLAYER_POLICE_SHOTTIME,2
	EndIf
	
	If AnimTime(PeekInt(p\bnkInfo,PLAYER_POLICE_MODEL))=>10
		If PeekInt(p\bnkInfo,PLAYER_POLICE_SHOTTIME) And 1 
			
			If EntityYaw(p\phx\entModel)<0 
				ATTACK_KICK_Damage(p,500,5,2,1) 
			Else 
				ATTACK_KICK_Damage(p,-500,5,-2,1) 
			EndIf 
			PokeInt p\bnkInfo,PLAYER_POLICE_SHOTTIME,0
			
		ElseIf PeekInt(p\bnkInfo,PLAYER_POLICE_SHOTTIME) And 2
			If EntityYaw(p\phx\entModel)<0
				ATTACK_KICK_Damage(p,500,20,5,3)
			Else
				ATTACK_KICK_Damage(p,-500,20,-5,3)
			EndIf
			
			PokeInt p\bnkInfo,PLAYER_POLICE_SHOTTIME,0
		EndIf
	EndIf
	
	
	If btnSmash
		
	EndIf
	
	
	If p\tmeStoned<MilliSecs()
		If Not(btnRight Or btnLeft) 
			Animate PeekInt(p\bnkInfo,PLAYER_POLICE_MODEL),0
		EndIf
	EndIf	
	
	Return
EndIf


;//-- Stick Soldier

Const PLAYER_STICK_SOLDIER_MESH=0,PLAYER_STICK_SOLDIER_ANIM_STAND=4,PLAYER_STICK_SOLDIER_ANIM_RUN=8
Const PLAYER_STICK_SOLDIER_ANIM_ATTACK=12,PLAYER_STICK_SOLDIER_ANIM_ATTACK2=16

c.character=New character
c\name="Stick Soldier"

tmp=Label2();input: c.character ;output:p.player
If proginit
	c\lblInit=tmp
Else
								;lblInit wird bei der Charakterwahl ausgefhrt. Ein Level l ist
								;noch nicht gesetzt. Aufgabe der lblInit eines Charaktrs ist es
								;einen p.player zu erstellen und ihn spielbereit zu laden.
	
								;Der folgede Teil ist immer gleich
	p=New player
	p\bnkInfo=CreateBank(20)	;/!\ Die Bankgre nach Bedarf anpassen
								;Dran denken: Ein Handle (zB von Models)
								;ist 4 Byte gro.
	
	p\phx=New phxEntity			;Hier wird Der Spieler als Physikalisches
								;Objekt erstellt, dass der Schwerkraft
								;unterliegt und sterben kann.
	p\phx\entModel=CreatePivot()
	EntityRadius(p\phx\entModel,12)
								;Dieser Pivot ist Pflicht und dient
								;als Kollisions-Entity
	p\c=c						;Dem Spieler den Charakter zuweisen
	EntityType p\phx\entModel,COLLISION_PLAYER
	EntityPickMode p\phx\entModel,1   ;} Wichtig fr Attacken.
	NameEntity p\phx\entModel,Handle(p)   ;}
	
	;Beispiel fr das Aussehen des Players
	
	PokeInt p\bnkInfo,PLAYER_STICK_SOLDIER_MESH,LoadAnimMesh("StickSoldier.b3d",p\phx\entModel)
	ScaleEntity PeekInt(p\bnkInfo,PLAYER_STICK_SOLDIER_MESH),1.5,1.5,1.5
	PositionEntity PeekInt(p\bnkInfo,PLAYER_STICK_SOLDIER_MESH),0,2,0
	PokeInt p\bnkInfo,PLAYER_STICK_SOLDIER_ANIM_RUN,ExtractAnimSeq(PeekInt(p\bnkInfo,PLAYER_STICK_SOLDIER_MESH),0,60)
	PokeInt p\bnkInfo,PLAYER_STICK_SOLDIER_ANIM_ATTACK,ExtractAnimSeq(PeekInt(p\bnkInfo,PLAYER_STICK_SOLDIER_MESH),60,90)
	PokeInt p\bnkInfo,PLAYER_STICK_SOLDIER_ANIM_ATTACK2,ExtractAnimSeq(PeekInt(p\bnkInfo,PLAYER_STICK_SOLDIER_MESH),90,120)
	PokeInt p\bnkInfo,PLAYER_STICK_SOLDIER_ANIM_STAND,ExtractAnimSeq(PeekInt(p\bnkInfo,PLAYER_STICK_SOLDIER_MESH),121,130)
	
	;EntityColor PeekInt(p\bnkInfo,PLAYER_NAME_Variable),255,0,0
	;Anstelle von EntityColor Variable,255,0,0
	
	Return
EndIf   

tmp=Label2();input: btnRight,btnLeft,btnUp,btnDown,btnAtt1,btnAtt2,btnSmash,p.player
If proginit
	c\lblMovement=tmp
Else
   ;lblMovement wird in der Hauptschleife fr jeden teilnehmenden
    ;Spieler ausgefhrt. Die Buttons Right und Left sind durch Downs
   ;und alle anderen nur durch Hits abgefragt.
	
	
	If btnRight
		p\phx\ax=p\phx\ax+0.7;Den Spieler beschleunigen
		RotateEntity p\phx\entModel,0,90,0   ;Den Spieler Drehen,
                        ;sodass er in die
                         ;Laufrichtugn schaut
		
	   ;Beispiel fr Animationssteuerung der Meshs beim Laufen.
		If Not Animating(PeekInt(p\bnkInfo,PLAYER_STICK_SOLDIER_MESH))
			Animate PeekInt(p\bnkInfo,PLAYER_STICK_SOLDIER_MESH),1,1,PeekInt(p\bnkInfo,PLAYER_STICK_SOLDIER_ANIM_RUN),1
		EndIf
		
	EndIf
	
	If btnLeft
		p\phx\ax=p\phx\ax-0.7;Den Spieler beschleunigen
		RotateEntity p\phx\entModel,0,-90,0  ;Den Spieler Drehen,
                        ;sodass er in die
                        ;Laufrichtugn schaut
		
		
	   ;Beispiel fr Animationssteuerung der Meshs beim Laufen.
		If Not Animating(PeekInt(p\bnkInfo,PLAYER_STICK_SOLDIER_MESH))
			Animate PeekInt(p\bnkInfo,PLAYER_STICK_SOLDIER_MESH),1,1,PeekInt(p\bnkInfo,PLAYER_STICK_SOLDIER_ANIM_RUN),1
		EndIf
		
	EndIf
	
	If btnUp
		p\phx\ay=p\phx\ay+10;Nach oben beschleunigen
	EndIf
	
	If btnDown
		p\phx\ay=p\phx\ay-10;Nach unten beschleunigen
	EndIf
	
	If btnAtt1 ;Beispiel-Atacke: Kick
		If EntityYaw(p\phx\entModel)>0 
			ATTACK_KICK_Damage(p,100,1,1,.5)
		Else
			ATTACK_KICK_Damage(p,-100,1,-1,.5)
		EndIf
		
		Animate PeekInt(p\bnkInfo,PLAYER_STICK_SOLDIER_MESH),3,1,PeekInt(p\bnkInfo,PLAYER_STICK_SOLDIER_ANIM_ATTACK)
		p\tmeStoned=MilliSecs()+50  
	EndIf
	
	If btnAtt2
		If EntityYaw(p\phx\entModel)>0 
			ATTACK_KICK_Damage(p,20,10,2,1.5)
		Else
			ATTACK_KICK_Damage(p,-20,10,-2,1.5)
		EndIf
		Animate PeekInt(p\bnkInfo,PLAYER_STICK_SOLDIER_MESH),3,1.5,PeekInt(p\bnkInfo,PLAYER_STICK_SOLDIER_ANIM_ATTACK2)
		p\tmeStoned=MilliSecs()+50 
	EndIf
	
	If btnSmash
      ;Auch eine Attacke
	EndIf
	
	If p\tmeStoned<MilliSecs()
		If Not(btnRight Or btnLeft)
			Animate PeekInt(p\bnkInfo,PLAYER_STICK_SOLDIER_MESH),3,1,PeekInt(p\bnkInfo,PLAYER_STICK_SOLDIER_ANIM_STAND),1
		EndIf
	EndIf
	
	Return
EndIf
	
;~IDEal Editor Parameters:
;~C#Blitz3D